﻿@echo off
:: /****************************************************************************
::  *   Copyright (C) 2010 by Claas Anders "CaScAdE" Rathje                    *
::  *   admiralcascade@gmail.com                                               *
::  *   Project-URL: http://www.mylifesucks.de/oss/c-osd/                      *
::  *                                                                          *
::  *   This program is free software; you can redistribute it and/or modify   *
::  *   it under the terms of the GNU General Public License as published by   *
::  *   the Free Software Foundation; either version 2 of the License.         *
::  *                                                                          *
::  *   This program is distributed in the hope that it will be useful,        *
::  *   but WITHOUT ANY WARRANTY; without even the implied warranty of         *
::  *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
::  *   GNU General Public License for more details.                           *
::  *                                                                          *
::  *   You should have received a copy of the GNU General Public License      *
::  *   along with this program; if not, write to the                          *
::  *   Free Software Foundation, Inc.,                                        *
::  *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
::  ****************************************************************************/

set DATE=20100501-1130
:: date /T

:: clean up first
del *.hex

:: build pal hex
set CFLAGS=-DNTSC=0 -DBUILDDATE=\"%DATE%\"
make clean
make
move C-OSD.hex C-OSD-%DATE%-pal.hex


:: build ntsc hex
set CFLAGS=-DNTSC=1 -DBUILDDATE=\"%DATE%\"
make clean
make
move C-OSD.hex C-OSD-%DATE%-ntsc.hex

:: build pal hex FCONLY
set CFLAGS=-DNTSC=0 -DFCONLY=1 -DBUILDDATE=\"%DATE%\"
make clean
make
move C-OSD.hex C-OSD-%DATE%-pal-fconly.hex

:: build ntsc hex FCONLY
set CFLAGS=-DNTSC=1 -DFCONLY=1 -DBUILDDATE=\"%DATE%\"
make clean
make
move C-OSD.hex C-OSD-%DATE%-ntsc-fconly.hex


:: build character files
:: PAL
set CFLAGS=-DNTSC=0 -DWRITECHARS=1 -DBUILDDATE=\"%DATE%\"
make clean
make
move C-OSD.hex C-OSD-characters-pal.hex

:: and NTSC as well
set CFLAGS=-DNTSC=1 -DWRITECHARS=1 -DBUILDDATE=\"%DATE%\"
make clean
make
move C-OSD.hex C-OSD-characters-ntsc.hex

:: clean up
make clean

:: show stats  f.e. http://etree.org/cgi-bin/counter.cgi/software/md5sum.exe
md5sum *.hex
::dir /A *.hex

:: pack all stuff
mkdir C-OSD-%DATE%
move *.hex C-OSD-%DATE%
copy ..\CHANGE.LOG C-OSD-%DATE%
copy ..\LICENSE.TXT C-OSD-%DATE%
copy ..\README.TXT C-OSD-%DATE%
:: 7zip command line version from http://www.7-zip.org
7za a -tzip  C-OSD-%DATE%.zip C-OSD-%DATE%

rmdir /S /Q C-OSD-%DATE%

dir /A C-OSD-%DATE%.zip

::echo "building based on revision $REVISION is now DONE..."

