/****************************************************************************
 *   Copyright (C) 2009-2010 by Claas Anders "CaScAdE" Rathje               *
 *   admiralcascade@gmail.com                                               *
 *   Project-URL: http://www.mylifesucks.de/oss/c-osd/                      *
 *                                                                          *
 *   This program is free software; you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by   *
 *   the Free Software Foundation; either version 2 of the License.         *
 *                                                                          *
 *   This program is distributed in the hope that it will be useful,        *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for more details.                           *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to the                          *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 ****************************************************************************/

/* ##########################################################################
 * compass stuff
 * ##########################################################################*/

/**
 * convert the <heading> gotton from NC into an index
 */
uint8_t heading_conv(uint16_t);

/**
 * convert the <heading> gotton from NC into a more
 * precise index
 */
uint8_t heading_fine_conv(uint16_t);

/**
 * draw a compass rose at <x>/<y> for <heading>
 */
void draw_compass(uint8_t, uint8_t, uint16_t);

/* ##########################################################################
 * battery index
 * ##########################################################################*/
/**
 * draw a battery symbol at <x>/<y> according to <voltage>
 */
void draw_battery(uint8_t, uint8_t, uint8_t, uint8_t, uint8_t);

/* ##########################################################################
 * variometer
 * ##########################################################################*/
/**
 * draw variometer arrows at <x>/<y> according to <variometer>
 */
void draw_variometer(uint8_t, uint8_t, int16_t);

/**
 * draw a bigger vario with middle at <x>/<y> acording to <variometer>
 */
void draw_big_variometer(uint8_t, uint8_t, int16_t);

/* ##########################################################################
 * artificial horizon
 * ##########################################################################*/
/**
 * draw roll und nick indicators (could be enhanced to full artificial horizon)
 * from line <firstline> to <listlines> for given <nick> and <roll> values
 */
void draw_artificial_horizon(uint8_t, uint8_t, int16_t, int16_t);

void draw_agressiva_artificial_horizon(uint8_t, uint8_t, int16_t, int16_t);
